package cn.cars.si.ss.tonic.service.relatives.impl;

package ..deTemp.1730265215383;

import cn.cars.si.ss.tonic.bean.SmFamilyDetailSnap;
import cn.cars.si.ss.tonic.bean.SmFamilyQatherSnap;
import cn.cars.si.ss.tonic.bean.SmRuleClass;
import cn.cars.si.ss.tonic.bean.SmSap;
import cn.cars.si.ss.tonic.bean.SmStandard;
import cn.cars.si.ss.tonic.bean.SmStandardRecord;
import cn.cars.si.ss.tonic.bean.SsOrg;
import cn.cars.si.ss.tonic.bean.dto.DroolsDto;
import cn.cars.si.ss.tonic.bean.dto.HandSubsidyDto;
import cn.cars.si.ss.tonic.bean.dto.SapDto;
import cn.cars.si.ss.tonic.bean.dto.SmApplyDetailDto;
import cn.cars.si.ss.tonic.bean.dto.SmEmpFamilyInfoSnapDto;
import cn.cars.si.ss.tonic.bean.dto.SmFamilyDto;
import cn.cars.si.ss.tonic.bean.dto.SmSzyDto;
import cn.cars.si.ss.tonic.bean.query.FinanceConfirmQuery;
import cn.cars.si.ss.tonic.bean.query.FlowHistoryQuery;
import cn.cars.si.ss.tonic.bean.query.HrCheckQuery;
import cn.cars.si.ss.tonic.bean.query.MedicalExpenseQuery;
import cn.cars.si.ss.tonic.bean.query.StaffFamilyDetailQuery;
import cn.cars.si.ss.tonic.bean.query.StaffFamilyQuery;
import cn.cars.si.ss.tonic.bean.query.UnitCheckQuery;
import cn.cars.si.ss.tonic.bean.vo.CandidateVo;
import cn.cars.si.ss.tonic.bean.vo.RelativesVo;
import cn.cars.si.ss.tonic.bean.vo.SapVo;
import cn.cars.si.ss.tonic.bean.vo.SmFamilyDetailSnapVo;
import cn.cars.si.ss.tonic.bean.vo.SmsRecordVo;
import cn.cars.si.ss.tonic.bean.vo.WorkFlowVo;
import cn.cars.si.ss.tonic.client.FlowClient;
import cn.cars.si.ss.tonic.client.JavaWorkFlowClient;
import cn.cars.si.ss.tonic.common.ReturnVo;
import cn.cars.si.ss.tonic.common.constant.CommonConstant;
import cn.cars.si.ss.tonic.common.constant.ENUM_EXCEPTION_CODE;
import cn.cars.si.ss.tonic.common.exception.BusinessException;
import cn.cars.si.ss.tonic.common.page.PageBean;
import cn.cars.si.ss.tonic.common.util.DateUtil;
import cn.cars.si.ss.tonic.common.util.DroolsUtil;
import cn.cars.si.ss.tonic.common.util.HttpRequestUtil;
import cn.cars.si.ss.tonic.common.util.StringUtil;
import cn.cars.si.ss.tonic.common.util.UUIDUtil;
import cn.cars.si.ss.tonic.mapper.MedicalExpenseMapper;
import cn.cars.si.ss.tonic.mapper.SmApplyStaffMapper;
import cn.cars.si.ss.tonic.mapper.SmFamilyDetailSnapMapper;
import cn.cars.si.ss.tonic.mapper.SmFamilyQatherSnapMapper;
import cn.cars.si.ss.tonic.mapper.SmSapMapper;
import cn.cars.si.ss.tonic.mapper.SmsRecordMapper;
import cn.cars.si.ss.tonic.mapper.SsOrgMapper;
import cn.cars.si.ss.tonic.service.relatives.MedicalExpenseService;
import cn.cars.si.ss.tonic.service.subsidystandard.SmStandardService;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.rails.entity.CnFlowHistory;
import cn.rails.util.MqUtils;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.google.common.collect.Lists;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;
import javax.annotation.Resource;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

@Service("MedicalExpenseService")
public class MedicalExpenseServiceImpl implements MedicalExpenseService {
  private static final Logger log = LoggerFactory.getLogger(cn.cars.si.ss.tonic.service.relatives.impl.MedicalExpenseServiceImpl.class);
  
  @Autowired
  JavaWorkFlowClient flowClients;
  
  @Resource
  private SmFamilyDetailSnapMapper smFamilyDetailSnapMapper;
  
  @Resource
  private SsOrgMapper ssOrgMapper;
  
  @Resource
  private MedicalExpenseMapper medicalExpenseMapper;
  
  @Resource
  private SmFamilyQatherSnapMapper smFamilyQatherSnapMapper;
  
  @Resource
  private SmSapMapper smSapMapper;
  
  @Autowired
  private SmStandardService smStandardService;
  
  @Autowired
  private FlowClient flowClient;
  
  @Value("${spring.application.name}")
  private String sServiceName;
  
  @Autowired
  private RedisTemplate redisTemplate;
  
  @Value("${syncMedical}")
  private String syncMedical;
  
  @Value("${syncRefund}")
  private String syncRefund;
  
  @Autowired
  private MqUtils mqUtils;
  
  @Autowired
  private SmsRecordMapper smsRecordMapper;
  
  @Autowired
  private SmApplyStaffMapper smApplyStaffMapper;
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> queryMedicalExpenseList(MedicalExpenseQuery query) {
    log.info("[供养直系亲属医疗费用补助][医疗费用录入][开始][查询条件]：{}", query);
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    if (StringUtil.isEmpty(query.getUserId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      List<SmFamilyDto> smFamilyDtoList = this.medicalExpenseMapper.queryMedicalExpenseList(query);
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      Map<Object, Object> map = new HashMap<>();
      List<SmFamilyDto> submitMoneyList = this.medicalExpenseMapper.queryTotalMoney(query.getUserId());
      map.put("submitMoneyList", submitMoneyList);
      pageBean.setItems(smFamilyDtoList);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
      returnVo.setMap(map);
    } catch (BusinessException e) {
      log.error("medical/queryMedicalExpenseList:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo<Boolean> deleteRelativesList(List<RelativesVo> list) {
    ReturnVo<Boolean> returnVo = new ReturnVo();
    for (RelativesVo ls : list) {
      if (ObjectUtils.isEmpty(ls.getSFamilyGuid())) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
    } 
    try {
      list.forEach(item -> {
            Boolean relatives = this.medicalExpenseMapper.deleteStaffFamily(item);
            if (relatives.booleanValue()) {
              returnVo.setSuccess(true);
              returnVo.setRetMessage("删除成功");
              returnVo.setRetCode("200");
              returnVo.setRetUrl("/medical/deleteRelativesList");
            } else {
              returnVo.setSuccess(false);
              returnVo.setRetMessage("删除失败");
              returnVo.setRetCode("400");
              returnVo.setRetUrl("/medical/deleteRelativesList");
            } 
          });
    } catch (BusinessException e) {
      log.error("medical/deleteRelativesList:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> querydoneList(MedicalExpenseQuery query) {
    log.info("[供养直系亲属医疗费用补助][医疗费用录入][开始][查询条件]：{}", query);
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    try {
      if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      List<SmFamilyDto> smFamilyDtoList = this.medicalExpenseMapper.querydoneList(query);
      for (SmFamilyDto item : smFamilyDtoList) {
        if (!StringUtil.isEmpty(item.getTypename())) {
          if (item.getsTypename().equals("9")) {
            item.setTypename("门诊");
            continue;
          } 
          if (item.getsTypename().equals("10"))
            item.setTypename("住院"); 
        } 
      } 
      Map<Object, Object> map = new HashMap<>();
      if (!ObjectUtils.isEmpty(smFamilyDtoList)) {
        BigDecimal totalMoney01 = this.medicalExpenseMapper.queryStaffFamilyList(((SmFamilyDto)smFamilyDtoList.get(0)).getsFamilyGuid(), null);
        BigDecimal totalMoney03 = this.medicalExpenseMapper.queryStaffFamilyList(null, ((SmFamilyDto)smFamilyDtoList.get(0)).getsCreateUser());
        if (totalMoney01 != null) {
          Double totalMoney02 = Double.valueOf(String.valueOf(totalMoney01));
          Double totalMoney04 = Double.valueOf(String.valueOf(totalMoney03));
          if (totalMoney02.doubleValue() <= totalMoney04.doubleValue() && totalMoney04.doubleValue() <= 50000.0D) {
            if (totalMoney02.doubleValue() > 0.0D) {
              map.put("totalMoney", totalMoney02);
            } else {
              map.put("totalMoney", Integer.valueOf(0));
            } 
          } else {
            map.put("totalMoney", Integer.valueOf(50000));
          } 
        } else {
          map.put("totalMoney", Integer.valueOf(0));
        } 
      } 
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(smFamilyDtoList);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
      returnVo.setMap(map);
    } catch (BusinessException e) {
      log.error("medical/querydoneList:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmEmpFamilyInfoSnapDto>>> queryStaffFamilyData(StaffFamilyQuery query) {
    ReturnVo<PageBean<List<SmEmpFamilyInfoSnapDto>>> returnVo = new ReturnVo();
    try {
      List<SmEmpFamilyInfoSnapDto> ssEmpInsuredDtoLst = this.medicalExpenseMapper.queryStaffFamilyDataList(query);
      String sImportDate = DateUtil.getDateStr(new Date(), "yyyy-MM");
      if (null != ssEmpInsuredDtoLst && ssEmpInsuredDtoLst.size() > 0)
        for (SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto : ssEmpInsuredDtoLst) {
          int totalCount = this.medicalExpenseMapper.totalCount(smEmpFamilyInfoSnapDto.getsGuid(), query.getUserId(), query.getSInstanceId(), query.getSCreateUser());
          smEmpFamilyInfoSnapDto.setCount(totalCount);
          SmFamilyDto smFamilyDto = new SmFamilyDto();
          smFamilyDto.setsFamilyGuid(smEmpFamilyInfoSnapDto.getsGuid());
          smFamilyDto.setsImportDate(sImportDate);
        }  
      returnVo.setSuccess(true);
      returnVo.setRetUrl("/medical/queryStaffFamilyData");
      returnVo.setRetCode("200");
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(ssEmpInsuredDtoLst);
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyData:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmEmpFamilyInfoSnapDto>>> selectStaffFamilyData(StaffFamilyQuery query) {
    ReturnVo<PageBean<List<SmEmpFamilyInfoSnapDto>>> returnVo = new ReturnVo();
    try {
      List<SmEmpFamilyInfoSnapDto> ssEmpInsuredDtoLst = this.medicalExpenseMapper.selectStaffFamilyDataList(query);
      String sImportDate = DateUtil.getDateStr(new Date(), "yyyy-MM");
      List<String> instanceIdList = new ArrayList<>();
      if (null != ssEmpInsuredDtoLst && ssEmpInsuredDtoLst.size() > 0) {
        if (!StringUtil.isEmpty(query.getSInstanceId())) {
          String[] split = query.getSInstanceId().split(",");
          for (String s : split)
            instanceIdList.add(s); 
        } 
        for (SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto : ssEmpInsuredDtoLst) {
          int totalCount = this.medicalExpenseMapper.totalCount2(smEmpFamilyInfoSnapDto.getsGuid(), query.getUserId(), instanceIdList, query.getSCreateUser());
          smEmpFamilyInfoSnapDto.setCount(totalCount);
          SmFamilyDto smFamilyDto = new SmFamilyDto();
          smFamilyDto.setsFamilyGuid(smEmpFamilyInfoSnapDto.getsGuid());
          smFamilyDto.setsImportDate(sImportDate);
        } 
      } 
      returnVo.setSuccess(true);
      returnVo.setRetUrl("/medical/queryStaffFamilyData");
      returnVo.setRetCode("200");
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(ssEmpInsuredDtoLst);
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyData:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> queryOutstanding(MedicalExpenseQuery query) {
    log.info("[手机端供养直系亲属医疗费用补助][医疗费用录入][开始][查询条件]：{}", query);
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    try {
      if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      List<String> instanceIdList = this.medicalExpenseMapper.queryFnishInfo(query);
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      List<SmFamilyDto> smFamilyDtoList = this.medicalExpenseMapper.selectDoneList(query, instanceIdList);
      for (SmFamilyDto item : smFamilyDtoList) {
        String workflowStateName = this.medicalExpenseMapper.queryWorkflowStateName(item.getsInstanceId());
        item.setsWorkflowStateName(workflowStateName);
        if (!StringUtil.isEmpty(item.getTypename())) {
          if (item.getsTypename().equals("9")) {
            item.setTypename("门诊");
            continue;
          } 
          if (item.getsTypename().equals("10"))
            item.setTypename("住院"); 
        } 
      } 
      Map<Object, Object> map = new HashMap<>();
      if (!ObjectUtils.isEmpty(smFamilyDtoList)) {
        BigDecimal totalMoney01 = this.medicalExpenseMapper.queryStaffFamilyList(((SmFamilyDto)smFamilyDtoList.get(0)).getsFamilyGuid(), null);
        BigDecimal totalMoney03 = this.medicalExpenseMapper.queryStaffFamilyList(null, ((SmFamilyDto)smFamilyDtoList.get(0)).getsCreateUser());
        if (totalMoney01 != null) {
          Double totalMoney02 = Double.valueOf(String.valueOf(totalMoney01));
          Double totalMoney04 = Double.valueOf(String.valueOf(totalMoney03));
          if (totalMoney02.doubleValue() <= totalMoney04.doubleValue() && totalMoney04.doubleValue() <= 50000.0D) {
            if (totalMoney02.doubleValue() > 0.0D) {
              map.put("totalMoney", totalMoney02);
            } else {
              map.put("totalMoney", Integer.valueOf(0));
            } 
          } else {
            map.put("totalMoney", Integer.valueOf(50000));
          } 
        } else {
          map.put("totalMoney", Integer.valueOf(0));
        } 
      } 
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(smFamilyDtoList);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
      returnVo.setMap(map);
    } catch (BusinessException e) {
      log.error("medical/querydoneList:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateSummaryMonth(UnitCheckQuery query) throws RuntimeException {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getSDefintionId()) || StringUtil.isEmpty(query.getUserId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    String sImportDate = DateUtil.getDateStr(new Date(), "yyyy-MM");
    query.setSState("0");
    List<SmFamilyQatherSnap> smFamilyQatherLst = this.smFamilyQatherSnapMapper.selectSmFamilyQatherLst(query);
    if (CollectionUtils.isEmpty(smFamilyQatherLst)) {
      returnVo.setRetMessage("没有待汇总单据");
      return returnVo;
    } 
    for (SmFamilyQatherSnap smFamilyQatherSnap : smFamilyQatherLst) {
      smFamilyQatherSnap.setsQatherId(UUIDUtil.get32UUID());
      smFamilyQatherSnap.setsImportDate(sImportDate);
      smFamilyQatherSnap.setsTypename("");
      smFamilyQatherSnap.setStatus("1");
      smFamilyQatherSnap.setdCreateDate(new Date());
      smFamilyQatherSnap.setsCreateUser("");
      smFamilyQatherSnap.setdUpdateDate(null);
      smFamilyQatherSnap.setsUpdateUser("");
      smFamilyQatherSnap.setsDeleteFlag("");
      smFamilyQatherSnap.setsSummaryName("");
      smFamilyQatherSnap.setsSummaryNo("");
    } 
    int intValue = (new Double(Math.ceil(smFamilyQatherLst.size() / 1000.0D))).intValue();
    List<SmFamilyQatherSnap> newLst = new ArrayList<>();
    for (int i = 0; i < intValue; i++) {
      if (i < intValue - 1) {
        newLst = smFamilyQatherLst.subList(i * 1000, (i + 1) * 1000);
      } else {
        newLst = smFamilyQatherLst.subList(i * 1000, smFamilyQatherLst.size());
      } 
      this.smFamilyQatherSnapMapper.insertBatch(newLst);
    } 
    query.setSState("1");
    query.setOldState("0");
    this.smFamilyQatherSnapMapper.updateSmFamilyQatherLst(query);
    returnVo.setSuccess(true);
    returnVo.setRetMessage("汇总成功");
    return returnVo;
  }
  
  public ReturnVo selectSummaryMonth(UnitCheckQuery query) throws RuntimeException {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
    query.setSState("1");
    List<SmFamilyQatherSnap> smFamilyQatherLst = this.smFamilyQatherSnapMapper.selectSmFamilyQatherTwoLst(query);
    Long countNums = Long.valueOf(page.getTotal());
    PageBean<SmFamilyQatherSnap> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
    pageBean.setItems(smFamilyQatherLst);
    returnVo.setSuccess(true);
    returnVo.setRetMessage("查询成功");
    returnVo.setObj(pageBean);
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateUnSummaryMonth(UnitCheckQuery query) throws RuntimeException {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    if (StringUtil.isNotEmpty(query.getSInstanceId())) {
      this.smFamilyQatherSnapMapper.updateBySInstanceId(query.getSInstanceId(), "0");
      this.smFamilyQatherSnapMapper.deleteBySInstanceId(query.getSInstanceId());
    } else {
      query.setSState("0");
      query.setOldState("1");
      this.smFamilyDetailSnapMapper.updateSmFamilyQatherLst(query);
      this.smFamilyQatherSnapMapper.deleteSmFamilyQatherLst(query);
    } 
    returnVo.setSuccess(true);
    returnVo.setRetMessage("修改成功");
    return returnVo;
  }
  
  public ReturnVo updateUnHrSummaryMonth(UnitCheckQuery query) throws RuntimeException {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    if (StringUtil.isNotEmpty(query.getSInstanceId())) {
      this.smFamilyQatherSnapMapper.updateBySInstanceId(query.getSInstanceId(), "1");
    } else {
      query.setSState("1");
      query.setOldState("2");
      this.smFamilyDetailSnapMapper.updateSmFamilyQatherLst(query);
    } 
    returnVo.setSuccess(true);
    returnVo.setRetMessage("修改成功");
    return returnVo;
  }
  
  public ReturnVo selectHrSummaryMonth(UnitCheckQuery query) throws RuntimeException {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
    query.setSState("2");
    List<SmFamilyQatherSnap> smFamilyQatherLst = this.smFamilyQatherSnapMapper.selectHrSummaryMonth(query);
    Long countNums = Long.valueOf(page.getTotal());
    PageBean<SmFamilyQatherSnap> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
    pageBean.setItems(smFamilyQatherLst);
    returnVo.setSuccess(true);
    returnVo.setRetMessage("查询成功");
    returnVo.setObj(pageBean);
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> queryStaffFamilyDetailDone(StaffFamilyDetailQuery query) throws RuntimeException {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryOneStaffFamily(query);
      log.info("smEmpFamilyInfoSnapDto:{}", smEmpFamilyInfoSnapDto);
      AtomicInteger number = new AtomicInteger();
      List<SmFamilyDto> familyInfoSnapDtoList = this.medicalExpenseMapper.queryStaffFamilyDetailDone(query);
      List<String> sInstanceId = this.medicalExpenseMapper.querySInstanceId(query);
      double[] moneyone = { 0.0D };
      double[] moneytwo = { 0.0D };
      double[] totalMoney = { 0.0D };
      List<Double> familyScale = new ArrayList<>();
      familyInfoSnapDtoList.forEach(item -> {
            if (item.getnMoneyone() != null) {
              Double nMoneyone = Double.valueOf(String.valueOf(item.getnMoneyone()));
              moneyone[0] = moneyone[0] + nMoneyone.doubleValue();
            } 
            if (item.getnMoneytwo() != null) {
              Double nMoneytwo = Double.valueOf(String.valueOf(item.getnMoneytwo()));
              moneytwo[0] = moneytwo[0] + nMoneytwo.doubleValue();
            } 
            if (item.getsTypename().equals("9")) {
              item.setTypename("门诊");
            } else if (item.getsTypename().equals("10")) {
              item.setTypename("住院");
            } 
            BigDecimal submitmoneys = item.getnSubmitmoney();
            if (submitmoneys != null)
              totalMoney[0] = totalMoney[0] + Double.valueOf(String.valueOf(submitmoneys)).doubleValue(); 
            item.setId(String.valueOf(number.getAndIncrement()));
            HandSubsidyDto handSubsidyDto = new HandSubsidyDto();
            if ("9".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdTradeDate());
            } else if ("10".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdOutHospitalDate());
            } 
            String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
            SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
            SmStandardRecord smStandardRecord = new SmStandardRecord();
            smStandardRecord.setnSfamilyQuota(Integer.valueOf((new Double(smStandard.getnAvailableRelatives())).intValue()));
            smStandardRecord.setnFamilyDeductible(Integer.valueOf((new Double(smStandard.getnDeductibleRelatives())).intValue()));
            smStandardRecord.setnFamilyRatio(Double.valueOf(NumberUtil.round(NumberUtil.div(smStandard.getsStandardRelatives(), 100.0F), 2).doubleValue()));
            BigDecimal nFamilyRatio = null;
            BigDecimal sFamilyDeductible = null;
            BigDecimal sfamilyQuota = null;
            if (!ObjectUtils.isEmpty(smStandardRecord)) {
              Double bigDecimal = smStandardRecord.getnFamilyRatio();
              nFamilyRatio = BigDecimal.valueOf(bigDecimal.doubleValue());
              Integer familyDeductible = smStandardRecord.getnFamilyDeductible();
              sFamilyDeductible = BigDecimal.valueOf(familyDeductible.intValue());
              sfamilyQuota = BigDecimal.valueOf(smStandardRecord.getnSfamilyQuota().intValue());
              item.setnScale(nFamilyRatio);
              item.setnPayStandard(sFamilyDeductible);
              familyScale.add(bigDecimal);
              familyScale.add(Double.valueOf(String.valueOf(familyDeductible)));
              familyScale.add(Double.valueOf(String.valueOf(sfamilyQuota)));
            } 
          });
      Map<Object, Object> map = new HashMap<>();
      if (totalMoney[0] <= CommonConstant.WITHIN_MAX_MONEY.doubleValue()) {
        map.put("totalMoney", Double.valueOf(totalMoney[0]));
      } else {
        map.put("totalMoney", CommonConstant.WITHIN_MAX_MONEY);
      } 
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setList(sInstanceId);
      returnVo.setObj(familyInfoSnapDtoList);
      returnVo.setMap(map);
      System.out.println("-------------------" + totalMoney[0]);
      returnVo.setRetUrl("/medical/queryStaffFamilyDetailDone");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyDetailDone:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> queryStaffFamilyDetailNew(StaffFamilyDetailQuery query) throws RuntimeException {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryOneStaffFamily(query);
      log.info("smEmpFamilyInfoSnapDto:{}", smEmpFamilyInfoSnapDto);
      AtomicInteger number = new AtomicInteger();
      List<SmFamilyDto> familyInfoSnapDtoList = this.medicalExpenseMapper.queryStaffFamilyDetailNew(query);
      List<String> sInstanceId = this.medicalExpenseMapper.querySInstanceId(query);
      double[] moneyone = { 0.0D };
      double[] moneytwo = { 0.0D };
      double[] totalMoney = { 0.0D };
      List<Double> familyScale = new ArrayList<>();
      familyInfoSnapDtoList.forEach(item -> {
            if (item.getnMoneyone() != null) {
              Double nMoneyone = Double.valueOf(String.valueOf(item.getnMoneyone()));
              moneyone[0] = moneyone[0] + nMoneyone.doubleValue();
            } 
            if (item.getnMoneytwo() != null) {
              Double nMoneytwo = Double.valueOf(String.valueOf(item.getnMoneytwo()));
              moneytwo[0] = moneytwo[0] + nMoneytwo.doubleValue();
            } 
            if (item.getsTypename().equals("9")) {
              item.setTypename("门诊");
            } else if (item.getsTypename().equals("10")) {
              item.setTypename("住院");
            } 
            BigDecimal submitmoneys = item.getnSubmitmoney();
            if (submitmoneys != null)
              totalMoney[0] = totalMoney[0] + Double.valueOf(String.valueOf(submitmoneys)).doubleValue(); 
            item.setId(String.valueOf(number.getAndIncrement()));
            HandSubsidyDto handSubsidyDto = new HandSubsidyDto();
            if ("9".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdTradeDate());
            } else if ("10".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdOutHospitalDate());
            } 
            String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
            SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
            SmStandardRecord smStandardRecord = new SmStandardRecord();
            smStandardRecord.setnSfamilyQuota(Integer.valueOf((new Double(smStandard.getnAvailableRelatives())).intValue()));
            smStandardRecord.setnFamilyDeductible(Integer.valueOf((new Double(smStandard.getnDeductibleRelatives())).intValue()));
            smStandardRecord.setnFamilyRatio(Double.valueOf(NumberUtil.round(NumberUtil.div(smStandard.getsStandardRelatives(), 100.0F), 2).doubleValue()));
            BigDecimal nFamilyRatio = null;
            BigDecimal sFamilyDeductible = null;
            BigDecimal sfamilyQuota = null;
            if (!ObjectUtils.isEmpty(smStandardRecord)) {
              Double bigDecimal = smStandardRecord.getnFamilyRatio();
              nFamilyRatio = BigDecimal.valueOf(bigDecimal.doubleValue());
              Integer familyDeductible = smStandardRecord.getnFamilyDeductible();
              sFamilyDeductible = BigDecimal.valueOf(familyDeductible.intValue());
              sfamilyQuota = BigDecimal.valueOf(smStandardRecord.getnSfamilyQuota().intValue());
              item.setnScale(nFamilyRatio);
              item.setnPayStandard(sFamilyDeductible);
              familyScale.add(bigDecimal);
              familyScale.add(Double.valueOf(String.valueOf(familyDeductible)));
              familyScale.add(Double.valueOf(String.valueOf(sfamilyQuota)));
            } 
          });
      Map<Object, Object> map = new HashMap<>();
      if (totalMoney[0] <= CommonConstant.WITHIN_MAX_MONEY.doubleValue()) {
        map.put("totalMoney", Double.valueOf(totalMoney[0]));
      } else {
        map.put("totalMoney", CommonConstant.WITHIN_MAX_MONEY);
      } 
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setList(sInstanceId);
      returnVo.setObj(familyInfoSnapDtoList);
      returnVo.setMap(map);
      System.out.println("-------------------" + totalMoney[0]);
      returnVo.setRetUrl("/medical/queryStaffFamilyDetailDone");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyDetailDone:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> queryStaffFamilyDetail(StaffFamilyDetailQuery query) {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryOneStaffFamily(query);
      log.info("smEmpFamilyInfoSnapDto:{}", smEmpFamilyInfoSnapDto);
      AtomicInteger number = new AtomicInteger();
      List<SmFamilyDto> familyInfoSnapDtoList = this.medicalExpenseMapper.queryStaffFamilyDetail(query);
      List<String> sInstanceId = this.medicalExpenseMapper.querySInstanceId(query);
      double[] moneyone = { 0.0D };
      double[] moneytwo = { 0.0D };
      double[] totalMoney = { 0.0D };
      List<Double> familyScale = new ArrayList<>();
      familyInfoSnapDtoList.forEach(item -> {
            if (item.getnMoneyone() != null) {
              log.info("getnMoneyone:" + item.getnMoneyone());
              Double nMoneyone = Double.valueOf(String.valueOf(item.getnMoneyone()));
              moneyone[0] = moneyone[0] + nMoneyone.doubleValue();
            } 
            if (item.getnMoneytwo() != null) {
              log.info("getnMoneytwo:" + item.getnMoneytwo());
              Double nMoneytwo = Double.valueOf(String.valueOf(item.getnMoneytwo()));
              moneytwo[0] = moneytwo[0] + nMoneytwo.doubleValue();
            } 
            if (item.getsTypename().equals("9")) {
              item.setTypename("门诊");
            } else if (item.getsTypename().equals("10")) {
              item.setTypename("住院");
            } 
            BigDecimal submitmoneys = item.getnSubmitmoney();
            if (submitmoneys != null) {
              log.info("submitmoneys:" + submitmoneys);
              totalMoney[0] = totalMoney[0] + Double.valueOf(String.valueOf(submitmoneys)).doubleValue();
            } 
            item.setId(String.valueOf(number.getAndIncrement()));
            HandSubsidyDto handSubsidyDto = new HandSubsidyDto();
            if ("9".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdTradeDate());
            } else if ("10".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdOutHospitalDate());
            } 
            String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
            SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
            SmStandardRecord smStandardRecord = new SmStandardRecord();
            smStandardRecord.setnSfamilyQuota(Integer.valueOf((new Double(smStandard.getnAvailableRelatives())).intValue()));
            smStandardRecord.setnFamilyDeductible(Integer.valueOf((new Double(smStandard.getnDeductibleRelatives())).intValue()));
            smStandardRecord.setnFamilyRatio(Double.valueOf(NumberUtil.round(NumberUtil.div(smStandard.getsStandardRelatives(), 100.0F), 2).doubleValue()));
            BigDecimal nFamilyRatio = null;
            BigDecimal sFamilyDeductible = null;
            BigDecimal sfamilyQuota = null;
            if (!ObjectUtils.isEmpty(smStandardRecord)) {
              log.info("getnFamilyRatio:" + smStandardRecord.getnFamilyRatio());
              log.info("getnFamilyDeductible:" + smStandardRecord.getnFamilyDeductible());
              log.info("getnSfamilyQuota:" + smStandardRecord.getnSfamilyQuota());
              Double bigDecimal = smStandardRecord.getnFamilyRatio();
              nFamilyRatio = BigDecimal.valueOf(bigDecimal.doubleValue());
              log.info("nFamilyRatio:" + nFamilyRatio);
              Integer familyDeductible = smStandardRecord.getnFamilyDeductible();
              sFamilyDeductible = BigDecimal.valueOf(familyDeductible.intValue());
              log.info("sFamilyDeductible:" + sFamilyDeductible);
              sfamilyQuota = BigDecimal.valueOf(smStandardRecord.getnSfamilyQuota().intValue());
              log.info("sfamilyQuota:" + sfamilyQuota);
              item.setnScale(nFamilyRatio);
              item.setnPayStandard(sFamilyDeductible);
              familyScale.add(bigDecimal);
              log.info("familyDeductible:" + familyDeductible);
              log.info("sfamilyQuota:" + sfamilyQuota);
              familyScale.add(Double.valueOf(String.valueOf(familyDeductible)));
              familyScale.add(Double.valueOf(String.valueOf(sfamilyQuota)));
            } 
          });
      Map<Object, Object> map = new HashMap<>();
      if (totalMoney[0] <= CommonConstant.WITHIN_MAX_MONEY.doubleValue()) {
        map.put("totalMoney", Double.valueOf(totalMoney[0]));
      } else {
        map.put("totalMoney", CommonConstant.WITHIN_MAX_MONEY);
      } 
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setList(sInstanceId);
      returnVo.setObj(familyInfoSnapDtoList);
      returnVo.setMap(map);
      System.out.println("-------------------" + totalMoney[0]);
      returnVo.setRetUrl("/medical/queryStaffFamilyDetail");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyDetail:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> selectStaffFamilyDetail(StaffFamilyDetailQuery query) {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryOneStaffFamily(query);
      AtomicInteger number = new AtomicInteger();
      List<String> sInstanceIdList = new ArrayList<>();
      if (!StringUtil.isEmpty(query.getSInstanceId()))
        for (String s : query.getSInstanceId().split(","))
          sInstanceIdList.add(s);  
      List<SmFamilyDto> familyInfoSnapDtoList = this.medicalExpenseMapper.selectStaffFamilyDetail(query, sInstanceIdList);
      List<String> sInstanceId = this.medicalExpenseMapper.querySInstanceId(query);
      double[] moneyone = { 0.0D };
      double[] moneytwo = { 0.0D };
      double[] totalMoney = { 0.0D };
      List<Double> familyScale = new ArrayList<>();
      familyInfoSnapDtoList.forEach(item -> {
            if (item.getnMoneyone() != null) {
              Double nMoneyone = Double.valueOf(String.valueOf(item.getnMoneyone()));
              moneyone[0] = moneyone[0] + nMoneyone.doubleValue();
            } 
            if (item.getnMoneytwo() != null) {
              Double nMoneytwo = Double.valueOf(String.valueOf(item.getnMoneytwo()));
              moneytwo[0] = moneytwo[0] + nMoneytwo.doubleValue();
            } 
            if (item.getsTypename().equals("9")) {
              item.setTypename("门诊");
            } else if (item.getsTypename().equals("10")) {
              item.setTypename("住院");
            } 
            BigDecimal submitmoneys = item.getnSubmitmoney();
            if (submitmoneys != null)
              totalMoney[0] = totalMoney[0] + Double.valueOf(String.valueOf(submitmoneys)).doubleValue(); 
            item.setId(String.valueOf(number.getAndIncrement()));
            HandSubsidyDto handSubsidyDto = new HandSubsidyDto();
            if ("9".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdTradeDate());
            } else if ("10".equals(item.getsTypename())) {
              handSubsidyDto = this.ssOrgMapper.selectPersonScale(smEmpFamilyInfoSnapDto.getsPersonGuid(), item.getdOutHospitalDate());
            } 
            String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
            SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
            SmStandardRecord smStandardRecord = new SmStandardRecord();
            smStandardRecord.setnSfamilyQuota(Integer.valueOf((new Double(smStandard.getnAvailableRelatives())).intValue()));
            smStandardRecord.setnFamilyDeductible(Integer.valueOf((new Double(smStandard.getnDeductibleRelatives())).intValue()));
            smStandardRecord.setnFamilyRatio(Double.valueOf(NumberUtil.round(NumberUtil.div(smStandard.getsStandardRelatives(), 100.0F), 2).doubleValue()));
            BigDecimal nFamilyRatio = null;
            BigDecimal sFamilyDeductible = null;
            BigDecimal sfamilyQuota = null;
            if (!ObjectUtils.isEmpty(smStandardRecord)) {
              Double bigDecimal = smStandardRecord.getnFamilyRatio();
              nFamilyRatio = BigDecimal.valueOf(bigDecimal.doubleValue());
              Integer familyDeductible = smStandardRecord.getnFamilyDeductible();
              sFamilyDeductible = BigDecimal.valueOf(familyDeductible.intValue());
              sfamilyQuota = BigDecimal.valueOf(smStandardRecord.getnSfamilyQuota().intValue());
              item.setnScale(nFamilyRatio);
              item.setnPayStandard(sFamilyDeductible);
              familyScale.add(bigDecimal);
              familyScale.add(Double.valueOf(String.valueOf(familyDeductible)));
              familyScale.add(Double.valueOf(String.valueOf(sfamilyQuota)));
            } 
          });
      Map<Object, Object> map = new HashMap<>();
      if (totalMoney[0] <= CommonConstant.WITHIN_MAX_MONEY.doubleValue()) {
        map.put("totalMoney", Double.valueOf(totalMoney[0]));
      } else {
        map.put("totalMoney", CommonConstant.WITHIN_MAX_MONEY);
      } 
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setObj(familyInfoSnapDtoList);
      returnVo.setList(sInstanceId);
      returnVo.setMap(map);
      System.out.println("-------------------" + totalMoney[0]);
      returnVo.setRetUrl("/medical/queryStaffFamilyDetail");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryStaffFamilyDetail:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo<PageBean<List<SmFamilyDto>>> saveStaffFamily(List<SmFamilyDto> smFamilyDtoLst) {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    log.info("[供养直系亲属医疗费用补助][保存家属就医信息集合][开始]");
    if (CollectionUtils.isEmpty(smFamilyDtoLst)) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    for (SmFamilyDto smFamilyDto : smFamilyDtoLst) {
      if (StringUtil.isEmpty(smFamilyDto.getsOriginalcode()) || 
        StringUtil.isEmpty(smFamilyDto.getUserId()) || StringUtil.isEmpty(smFamilyDto.getsFamilyGuid()) || 
        StringUtil.isEmpty(smFamilyDto.getSealOrgHid()) || 
        StringUtil.isEmpty(smFamilyDto.getsFamilyRelationName()) || 
        StringUtil.isEmpty(smFamilyDto.getsPersonGuid())) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      if (smFamilyDto.getsTypename().equals("10") && null == smFamilyDto.getdOutHospitalDate()) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      if (smFamilyDto.getsTypename().equals("9") && null == smFamilyDto.getdTradeDate()) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      if (smFamilyDto.getsTypename().equals("10"))
        smFamilyDto.setdTradeDate(smFamilyDto.getdOutHospitalDate()); 
    } 
    for (int i = 0; i < smFamilyDtoLst.size(); i++) {
      for (int j = 0; j < smFamilyDtoLst.size(); j++) {
        if (i != j) {
          if (((SmFamilyDto)smFamilyDtoLst.get(i)).getsTypename().equals("10"))
            ((SmFamilyDto)smFamilyDtoLst.get(i)).setdTradeDate(((SmFamilyDto)smFamilyDtoLst.get(i)).getdOutHospitalDate()); 
          if (((SmFamilyDto)smFamilyDtoLst.get(i)).getdTradeDate().equals(((SmFamilyDto)smFamilyDtoLst.get(j)).getdTradeDate()) && ((SmFamilyDto)smFamilyDtoLst
            .get(i)).getsOriginalcode().equals(((SmFamilyDto)smFamilyDtoLst.get(j)).getsOriginalcode())) {
            returnVo.setRetMessage(((SmFamilyDto)smFamilyDtoLst.get(i)).getdTradeDate() + ":" + ((SmFamilyDto)smFamilyDtoLst.get(i)).getsOriginalcode() + "流水号重复!");
            return returnVo;
          } 
        } 
      } 
    } 
    RelativesVo sPersonIdcardN = new RelativesVo();
    for (SmFamilyDto item : smFamilyDtoLst) {
      if (item.getsTypename().equals("9")) {
        sPersonIdcardN = this.medicalExpenseMapper.getsPersonIdcardNo(item.getsEmpGuid(), item.getsFamilyGuid(), item.getdTradeDate());
      } else {
        sPersonIdcardN = this.medicalExpenseMapper.getsPersonIdcardNo(item.getsEmpGuid(), item.getsFamilyGuid(), item.getdOutHospitalDate());
      } 
      if (null == sPersonIdcardN) {
        returnVo.setSuccess(false);
        returnVo.setRetMessage("保存失败" + item.getsOriginalcode() + "不在备案有效期内");
        return returnVo;
      } 
    } 
    String sInstanceId = "";
    for (SmFamilyDto item : smFamilyDtoLst) {
      if (StringUtils.isNotBlank(item.getsInstanceId())) {
        sInstanceId = item.getsInstanceId();
        break;
      } 
    } 
    for (SmFamilyDto item : smFamilyDtoLst) {
      int sOriginalcode = this.medicalExpenseMapper.selectByCodeAndInstanceId(item.getsOriginalcode(), item.getsFamilyGuid(), sInstanceId);
      if (sOriginalcode >= 1) {
        returnVo.setRetMessage("流水号重复!");
        return returnVo;
      } 
    } 
    for (SmFamilyDto item : smFamilyDtoLst) {
      HandSubsidyDto handSubsidyDto = this.ssOrgMapper.selectPersonScale(item.getsEmpGuid(), item.getdTradeDate());
      String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
      SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
      if (null == smStandard) {
        returnVo.setRetMessage("Redis无效，联系管理员");
        return returnVo;
      } 
    } 
    List<SmFamilyQatherSnap> smFamilyQatherSnapLst = this.smFamilyQatherSnapMapper.selectInstanceId(sInstanceId);
    if (!CollectionUtils.isEmpty(smFamilyQatherSnapLst)) {
      returnVo.setRetMessage("已做汇总操作，请先解除汇总。");
      return returnVo;
    } 
    try {
      List<WorkFlowVo> workFlowVoList = this.medicalExpenseMapper.selectInstanceIdByFamilyGuid(((SmFamilyDto)smFamilyDtoLst.get(0)).getsFamilyGuid());
      if (CollectionUtils.isNotEmpty(workFlowVoList))
        for (WorkFlowVo workFlowVo : workFlowVoList) {
          if (StringUtils.isNotBlank(workFlowVo.getsPrevUserid()) && !Objects.equals(((SmFamilyDto)smFamilyDtoLst.get(0)).getUserId(), workFlowVo.getsPrevUserid())) {
            returnVo.setSuccess(false);
            returnVo.setRetMessage("流程审批中，请勿多次提交！");
            return returnVo;
          } 
        }  
      if (StringUtil.isEmpty(sInstanceId)) {
        List<SmFamilyDetailSnapVo> smFamilyDetailSnapVoList = this.medicalExpenseMapper.selectBysCreateUser(((SmFamilyDto)smFamilyDtoLst.get(0)).getsCreateUser());
        if (CollectionUtils.isEmpty(smFamilyDetailSnapVoList)) {
          returnVo.setRetMessage("保存失败");
          return returnVo;
        } 
        StringBuffer stringBuffer = new StringBuffer();
        smFamilyDetailSnapVoList.forEach(ite -> stringBuffer.append(ite.getSRoleGuid() + ","));
        String workflowTaskGroup = stringBuffer.toString();
        HashMap<String, String> map = new HashMap<>();
        map.put("path", "QYZXQS_MEDICAL_AID");
        map.put("workflowTaskGroup", workflowTaskGroup);
        CnFlowHistory cnFlowHistory = new CnFlowHistory();
        cnFlowHistory.setsServiceName(this.sServiceName);
        cnFlowHistory.setsVariables(map);
        cnFlowHistory.setsDefintionId("QYZXQS_MEDICAL_AID");
        cnFlowHistory.setsPrevUserid(((SmFamilyDto)smFamilyDtoLst.get(0)).getsCreateUser());
        cnFlowHistory.setsPrevUsername(((SmFamilyDetailSnapVo)smFamilyDetailSnapVoList.get(0)).getUserName());
        cnFlowHistory.setsOperationType("INSTANCE_WORKFLOW");
        cnFlowHistory.setdOperationDate(new Date());
        CnFlowHistory flowHistory = this.flowClient.beginWorkFlow(cnFlowHistory);
        if (StringUtil.isEmpty(flowHistory.getsInstanceId())) {
          returnVo.setRetMessage("保存失败");
          return returnVo;
        } 
        sInstanceId = flowHistory.getsInstanceId();
      } 
      if (StringUtils.isNotBlank(sInstanceId)) {
        RelativesVo relativesVo = new RelativesVo();
        relativesVo.setSInstanceId(sInstanceId);
        this.medicalExpenseMapper.deleteStaffFamily(relativesVo);
      } 
      for (SmFamilyDto item : smFamilyDtoLst) {
        HandSubsidyDto handSubsidyDto = this.ssOrgMapper.selectPersonScale(item.getsEmpGuid(), item.getdTradeDate());
        String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
        SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
        BigDecimal nFamilyRatio = new BigDecimal(NumberUtil.round(NumberUtil.div(smStandard.getsStandardRelatives(), 100.0F), 2).doubleValue());
        BigDecimal sFamilyDeductible = new BigDecimal(smStandard.getnDeductibleRelatives());
        BigDecimal sfamilyQuota = new BigDecimal(smStandard.getnAvailableRelatives());
        BigDecimal nDeductible = this.medicalExpenseMapper.selectDeductible(item.getsFamilyGuid(), DateUtil.getYearStar(item.getdTradeDate()), DateUtil.getYearEnd(item.getdTradeDate()));
        BigDecimal subsidyTotal = this.medicalExpenseMapper.selectsubsidyTotal(item.getsEmpGuid(), DateUtil.getYearStar(item.getdTradeDate()), DateUtil.getYearEnd(item.getdTradeDate()));
        SmFamilyDetailSnap smFamilyDetailSnap = new SmFamilyDetailSnap();
        smFamilyDetailSnap.setsDetallId(UUIDUtil.get32UUID());
        smFamilyDetailSnap.setsOriginalcode(item.getsOriginalcode());
        smFamilyDetailSnap.setsInstanceId(sInstanceId);
        if (!StringUtil.isEmpty(item.getsPersonName()))
          smFamilyDetailSnap.setsPersonName(item.getsPersonName()); 
        if (!StringUtil.isEmpty(item.getsName()))
          smFamilyDetailSnap.setsPersonName(item.getsName()); 
        smFamilyDetailSnap.setsPersonGuid(item.getsPersonGuid());
        smFamilyDetailSnap.setsPersonIdcardNo(sPersonIdcardN.getSDetallId());
        smFamilyDetailSnap.setsFamilyGuid(item.getsFamilyGuid());
        smFamilyDetailSnap.setsUnitName(item.getsUnitName());
        smFamilyDetailSnap.setSealOrgHid(item.getSealOrgHid());
        smFamilyDetailSnap.setsFamilyName(item.getsFamilyName());
        smFamilyDetailSnap.setsFamilyRelation(item.getsFamilyRelationName());
        smFamilyDetailSnap.setsFamilyIdcardNo(sPersonIdcardN.getSFamilyGuid());
        smFamilyDetailSnap.setsFamilySex(((SmFamilyDto)smFamilyDtoLst.get(0)).getsFamilySex());
        smFamilyDetailSnap.setnCostTotalMoney(item.getnCostTotalMoney());
        smFamilyDetailSnap.setnHospital(item.getnHospital());
        smFamilyDetailSnap.setsFlagStandard("0");
        smFamilyDetailSnap.setnScaleOne(nFamilyRatio);
        smFamilyDetailSnap.setnWithinMaxMoney(sfamilyQuota);
        smFamilyDetailSnap.setStatus("0");
        smFamilyDetailSnap.setdCreateDate(new Date());
        smFamilyDetailSnap.setdUpdateDate(new Date());
        smFamilyDetailSnap.setsUpdateUser(item.getsUpdateUser());
        smFamilyDetailSnap.setsSummaryName(item.getsSummaryName());
        smFamilyDetailSnap.setsSummaryNo(item.getsSummaryNo());
        smFamilyDetailSnap.setsCreateUser(item.getsCreateUser());
        smFamilyDetailSnap.setsDeleteFlag("0");
        smFamilyDetailSnap.setdInHospitalDate(item.getdInHospitalDate());
        smFamilyDetailSnap.setdOutHospitalDate(item.getdOutHospitalDate());
        smFamilyDetailSnap.setsTypename(item.getsTypename());
        smFamilyDetailSnap.setdTradeDate(item.getdTradeDate());
        smFamilyDetailSnap.setnMoneyone(item.getnMoneyone());
        smFamilyDetailSnap.setnMoneytwo(item.getnMoneytwo());
        if (subsidyTotal.compareTo(sfamilyQuota) >= 0) {
          smFamilyDetailSnap.setnSubmitmoney(BigDecimal.valueOf(0L));
        } else {
          BigDecimal totalAdd = NumberUtil.round(NumberUtil.add(item.getnMoneyone(), item.getnMoneytwo()), 2);
          if (NumberUtil.add(nDeductible, totalAdd).compareTo(sFamilyDeductible) <= 0) {
            smFamilyDetailSnap.setnSubmitmoney(BigDecimal.valueOf(0L));
          } else if (nDeductible.compareTo(sFamilyDeductible) >= 0) {
            BigDecimal nSubmitmoney = NumberUtil.mul(totalAdd, nFamilyRatio);
            if (NumberUtil.add(subsidyTotal, nSubmitmoney).compareTo(sfamilyQuota) > 0) {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(NumberUtil.sub(sfamilyQuota, subsidyTotal), 2));
            } else {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(nSubmitmoney, 2));
            } 
          } else if (nDeductible.compareTo(sFamilyDeductible) < 0) {
            BigDecimal nSubmitmoney = NumberUtil.mul(NumberUtil.sub(NumberUtil.add(nDeductible, totalAdd), sFamilyDeductible), nFamilyRatio);
            if (NumberUtil.add(subsidyTotal, nSubmitmoney).compareTo(sfamilyQuota) > 0) {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(NumberUtil.sub(sfamilyQuota, subsidyTotal), 2));
            } else {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(nSubmitmoney, 2));
            } 
          } 
        } 
        smFamilyDetailSnap.setnPayStandard(sFamilyDeductible);
        smFamilyDetailSnap.setnOwnsubmoney(item.getnOwnsubmoney());
        this.medicalExpenseMapper.insert(smFamilyDetailSnap);
      } 
      returnVo.setSuccess(true);
      returnVo.setRetMessage("保存成功");
    } catch (BusinessException e) {
      log.error("medical/saveStaffFamily:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> showStaffFamily(List<SmFamilyDto> smFamilyDtoLst) {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (CollectionUtils.isEmpty(smFamilyDtoLst)) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    for (SmFamilyDto smFamilyDto : smFamilyDtoLst) {
      if (smFamilyDto.getsTypename().equals("10") && null == smFamilyDto.getdOutHospitalDate()) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      if (smFamilyDto.getsTypename().equals("9") && null == smFamilyDto.getdTradeDate()) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      if (smFamilyDto.getsTypename().equals("10"))
        smFamilyDto.setdTradeDate(smFamilyDto.getdOutHospitalDate()); 
    } 
    for (int i = 0; i < smFamilyDtoLst.size(); i++) {
      for (int j = 0; j < smFamilyDtoLst.size(); j++) {
        if (i != j) {
          if (((SmFamilyDto)smFamilyDtoLst.get(i)).getsTypename().equals("10"))
            ((SmFamilyDto)smFamilyDtoLst.get(i)).setdTradeDate(((SmFamilyDto)smFamilyDtoLst.get(i)).getdOutHospitalDate()); 
          if (((SmFamilyDto)smFamilyDtoLst.get(i)).getdTradeDate().equals(((SmFamilyDto)smFamilyDtoLst.get(j)).getdTradeDate()) && ((SmFamilyDto)smFamilyDtoLst
            .get(i)).getsOriginalcode().equals(((SmFamilyDto)smFamilyDtoLst.get(j)).getsOriginalcode())) {
            returnVo.setRetMessage(((SmFamilyDto)smFamilyDtoLst.get(i)).getdTradeDate() + ":" + ((SmFamilyDto)smFamilyDtoLst.get(i)).getsOriginalcode() + "流水号重复!");
            return returnVo;
          } 
        } 
      } 
    } 
    RelativesVo sPersonIdcardN = new RelativesVo();
    for (SmFamilyDto item : smFamilyDtoLst) {
      if (item.getsTypename().equals("9")) {
        sPersonIdcardN = this.medicalExpenseMapper.getsPersonIdcardNo(item.getsEmpGuid(), item.getsFamilyGuid(), item.getdTradeDate());
      } else {
        sPersonIdcardN = this.medicalExpenseMapper.getsPersonIdcardNo(item.getsEmpGuid(), item.getsFamilyGuid(), item.getdOutHospitalDate());
      } 
      if (null == sPersonIdcardN) {
        returnVo.setSuccess(false);
        returnVo.setRetMessage("保存失败" + item.getsOriginalcode() + "不在备案有效期内");
        return returnVo;
      } 
    } 
    String sInstanceId = "";
    for (SmFamilyDto item : smFamilyDtoLst) {
      if (StringUtils.isNotBlank(item.getsInstanceId())) {
        sInstanceId = item.getsInstanceId();
        break;
      } 
    } 
    for (SmFamilyDto item : smFamilyDtoLst) {
      int sOriginalcode = this.medicalExpenseMapper.selectByCodeAndInstanceId(item.getsOriginalcode(), item.getsFamilyGuid(), sInstanceId);
      if (sOriginalcode >= 1) {
        returnVo.setRetMessage("流水号重复!");
        return returnVo;
      } 
    } 
    for (SmFamilyDto item : smFamilyDtoLst) {
      HandSubsidyDto handSubsidyDto = this.ssOrgMapper.selectPersonScale(item.getsEmpGuid(), item.getdTradeDate());
      String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
      SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
      if (null == smStandard) {
        returnVo.setRetMessage("Redis无效，联系管理员");
        return returnVo;
      } 
    } 
    try {
      List<SmFamilyDto> oldbList = Lists.newArrayList();
      if (StringUtils.isNotBlank(sInstanceId))
        oldbList.addAll(this.medicalExpenseMapper.selectListByInstanceId(sInstanceId)); 
      for (SmFamilyDto item : smFamilyDtoLst) {
        if (StringUtils.isNotBlank(item.getsInstanceId()) && 
          ObjectUtil.isEmpty(item.getnSubmitmoney()))
          item.setnSubmitmoney(BigDecimal.ZERO); 
      } 
      Map<Object, Object> map = new HashMap<>();
      List<SmFamilyDetailSnap> subList = Lists.newArrayList();
      BigDecimal nDeductible = this.medicalExpenseMapper.selectDeductible(((SmFamilyDto)smFamilyDtoLst.get(0)).getsFamilyGuid(), DateUtil.getYearStar(((SmFamilyDto)smFamilyDtoLst.get(0)).getdTradeDate()), DateUtil.getYearEnd(((SmFamilyDto)smFamilyDtoLst.get(0)).getdTradeDate()));
      BigDecimal subsidyTotal = this.medicalExpenseMapper.selectsubsidyTotal(((SmFamilyDto)smFamilyDtoLst.get(0)).getsEmpGuid(), DateUtil.getYearStar(((SmFamilyDto)smFamilyDtoLst.get(0)).getdTradeDate()), DateUtil.getYearEnd(((SmFamilyDto)smFamilyDtoLst.get(0)).getdTradeDate()));
      if (CollectionUtil.isNotEmpty(oldbList)) {
        BigDecimal one = oldbList.stream().map(SmFamilyDto::getnMoneyone).reduce(BigDecimal.ZERO, BigDecimal::add);
        BigDecimal two = oldbList.stream().map(SmFamilyDto::getnMoneytwo).reduce(BigDecimal.ZERO, BigDecimal::add);
        BigDecimal sub = oldbList.stream().map(SmFamilyDto::getnSubmitmoney).reduce(BigDecimal.ZERO, BigDecimal::add);
        BigDecimal add = NumberUtil.add(one, two);
        nDeductible = NumberUtil.sub(nDeductible, add);
        subsidyTotal = NumberUtil.sub(subsidyTotal, sub);
      } 
      for (SmFamilyDto item : smFamilyDtoLst) {
        HandSubsidyDto handSubsidyDto = this.ssOrgMapper.selectPersonScale(item.getsEmpGuid(), item.getdTradeDate());
        String strRedis = (String)this.redisTemplate.opsForValue().get("drools:" + handSubsidyDto.getsEmployeeStatus() + "_" + handSubsidyDto.getsSsd() + "_" + handSubsidyDto.getsSmc() + "_" + handSubsidyDto.getsSht());
        SmStandard smStandard = (SmStandard)JSONObject.parseObject(strRedis, SmStandard.class);
        BigDecimal nFamilyRatio = new BigDecimal(smStandard.getsStandardRelatives());
        BigDecimal sFamilyDeductible = new BigDecimal(smStandard.getnDeductibleRelatives());
        BigDecimal sfamilyQuota = new BigDecimal(smStandard.getnAvailableRelatives());
        if (CollectionUtil.isNotEmpty(subList)) {
          BigDecimal one = subList.stream().map(SmFamilyDetailSnap::getnMoneyone).reduce(BigDecimal.ZERO, BigDecimal::add);
          BigDecimal two = subList.stream().map(SmFamilyDetailSnap::getnMoneytwo).reduce(BigDecimal.ZERO, BigDecimal::add);
          BigDecimal sub = subList.stream().map(SmFamilyDetailSnap::getnSubmitmoney).reduce(BigDecimal.ZERO, BigDecimal::add);
          BigDecimal add = NumberUtil.add(one, two);
          nDeductible = NumberUtil.add(nDeductible, add);
          subsidyTotal = NumberUtil.add(subsidyTotal, sub);
        } 
        SmFamilyDetailSnap smFamilyDetailSnap = new SmFamilyDetailSnap();
        smFamilyDetailSnap.setsDetallId(UUIDUtil.get32UUID());
        smFamilyDetailSnap.setsOriginalcode(item.getsOriginalcode());
        smFamilyDetailSnap.setsInstanceId(sInstanceId);
        if (!StringUtil.isEmpty(item.getsPersonName()))
          smFamilyDetailSnap.setsPersonName(item.getsPersonName()); 
        if (!StringUtil.isEmpty(item.getsName()))
          smFamilyDetailSnap.setsPersonName(item.getsName()); 
        smFamilyDetailSnap.setsPersonGuid(item.getsPersonGuid());
        smFamilyDetailSnap.setsPersonIdcardNo(sPersonIdcardN.getSDetallId());
        smFamilyDetailSnap.setsFamilyGuid(item.getsFamilyGuid());
        smFamilyDetailSnap.setsUnitName(item.getsUnitName());
        smFamilyDetailSnap.setSealOrgHid(item.getSealOrgHid());
        smFamilyDetailSnap.setsFamilyName(item.getsFamilyName());
        smFamilyDetailSnap.setsFamilyRelation(item.getsFamilyRelationName());
        smFamilyDetailSnap.setsFamilyIdcardNo(sPersonIdcardN.getSFamilyGuid());
        smFamilyDetailSnap.setsFamilySex(((SmFamilyDto)smFamilyDtoLst.get(0)).getsFamilySex());
        smFamilyDetailSnap.setnCostTotalMoney(item.getnCostTotalMoney());
        smFamilyDetailSnap.setnHospital(item.getnHospital());
        smFamilyDetailSnap.setsFlagStandard("0");
        smFamilyDetailSnap.setnScaleOne(nFamilyRatio);
        smFamilyDetailSnap.setnWithinMaxMoney(sfamilyQuota);
        smFamilyDetailSnap.setStatus("0");
        smFamilyDetailSnap.setdCreateDate(new Date());
        smFamilyDetailSnap.setdUpdateDate(new Date());
        smFamilyDetailSnap.setsUpdateUser(item.getsUpdateUser());
        smFamilyDetailSnap.setsSummaryName(item.getsSummaryName());
        smFamilyDetailSnap.setsSummaryNo(item.getsSummaryNo());
        smFamilyDetailSnap.setsCreateUser(item.getsCreateUser());
        smFamilyDetailSnap.setsDeleteFlag("0");
        smFamilyDetailSnap.setdInHospitalDate(item.getdInHospitalDate());
        smFamilyDetailSnap.setdOutHospitalDate(item.getdOutHospitalDate());
        smFamilyDetailSnap.setsTypename(item.getsTypename());
        smFamilyDetailSnap.setdTradeDate(item.getdTradeDate());
        smFamilyDetailSnap.setnMoneyone(item.getnMoneyone());
        smFamilyDetailSnap.setnMoneytwo(item.getnMoneytwo());
        if (subsidyTotal.compareTo(sfamilyQuota) >= 0) {
          smFamilyDetailSnap.setnSubmitmoney(BigDecimal.valueOf(0L));
        } else {
          BigDecimal totalAdd = NumberUtil.round(NumberUtil.add(item.getnMoneyone(), item.getnMoneytwo()), 2);
          if (NumberUtil.add(nDeductible, totalAdd).compareTo(sFamilyDeductible) <= 0) {
            smFamilyDetailSnap.setnSubmitmoney(BigDecimal.valueOf(0L));
          } else if (nDeductible.compareTo(sFamilyDeductible) >= 0) {
            BigDecimal nSubmitmoney = NumberUtil.mul(totalAdd, nFamilyRatio);
            if (NumberUtil.add(subsidyTotal, nSubmitmoney).compareTo(sfamilyQuota) > 0) {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(NumberUtil.sub(sfamilyQuota, subsidyTotal), 2));
            } else {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(nSubmitmoney, 2));
            } 
          } else if (nDeductible.compareTo(sFamilyDeductible) < 0) {
            BigDecimal nSubmitmoney = NumberUtil.mul(NumberUtil.sub(NumberUtil.add(nDeductible, totalAdd), sFamilyDeductible), nFamilyRatio);
            if (NumberUtil.add(subsidyTotal, nSubmitmoney).compareTo(sfamilyQuota) > 0) {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(NumberUtil.sub(sfamilyQuota, subsidyTotal), 2));
            } else {
              smFamilyDetailSnap.setnSubmitmoney(NumberUtil.round(nSubmitmoney, 2));
            } 
          } 
        } 
        smFamilyDetailSnap.setnPayStandard(sFamilyDeductible);
        smFamilyDetailSnap.setnOwnsubmoney(item.getnOwnsubmoney());
        subList.add(smFamilyDetailSnap);
      } 
      map.put("totalMoney", subList.stream().map(SmFamilyDetailSnap::getnSubmitmoney).reduce(BigDecimal.ZERO, BigDecimal::add));
      returnVo.setMap(map);
      returnVo.setSuccess(true);
    } catch (BusinessException e) {
      log.error("medical/showStaffFamily:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo<PageBean<List<SmFamilyDto>>> showStaffFamilyNew(List<SmFamilyDto> smFamilyDtoLst) {
    ReturnVo<PageBean<List<SmFamilyDto>>> returnVo = new ReturnVo();
    Map<Object, Object> map = new HashMap<>();
    map.put("totalMoney", null);
    returnVo.setMap(map);
    returnVo.setSuccess(true);
    return returnVo;
  }
  
  public ReturnVo queryNextLine(UnitCheckQuery query) {
    log.info("[家属人员查询下一条开始][查询条件]：{}", query);
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getEmpGuid()) && StringUtil.isEmpty(query.getSFamilyGuid())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryNextLine(query);
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setRetUrl("/medical/queryNextLine");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryNextLine:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo queryPreviousLine(UnitCheckQuery query) {
    log.info("[家属人员查询上一条开始][查询条件]：{}", query);
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getEmpGuid()) && StringUtil.isEmpty(query.getSFamilyGuid())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      SmEmpFamilyInfoSnapDto smEmpFamilyInfoSnapDto = this.medicalExpenseMapper.queryPreviousLine(query);
      returnVo.setBean(smEmpFamilyInfoSnapDto);
      returnVo.setRetUrl("/medical/queryPreviousLine");
      returnVo.setRetCode("200");
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
    } catch (BusinessException e) {
      log.error("medical/queryPreviousLine:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo getFlowHistoryList(String serverName, String definitionId, String instanceId) {
    return this.flowClient.getWorkFlowActionHistoryList(serverName, definitionId, instanceId);
  }
  
  @Transactional
  public ReturnVo<Boolean> deleteStaffFamily(RelativesVo relativesVo) {
    ReturnVo<Boolean> returnVo = new ReturnVo();
    if (StringUtils.isBlank(relativesVo.getSInstanceId()) || StringUtils.isBlank(relativesVo.getSFamilyGuid())) {
      returnVo.setSuccess(false);
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Boolean deleteStaffFamily = this.medicalExpenseMapper.deleteStaffFamily(relativesVo);
      if (deleteStaffFamily.booleanValue()) {
        StaffFamilyDetailQuery query = new StaffFamilyDetailQuery();
        query.setNstep("99");
        query.setQueryType(Integer.valueOf(1));
        query.setSDefintionId("QYZXQS_MEDICAL_AID");
        query.setSInstanceId(relativesVo.getSInstanceId());
        query.setSUserGuid(relativesVo.getSFamilyGuid());
        ReturnVo<PageBean<List<SmFamilyDto>>> pageBeanReturnVo = queryStaffFamilyDetail(query);
        List<SmFamilyDto> list = (List<SmFamilyDto>)pageBeanReturnVo.getObj();
        if (CollectionUtils.isNotEmpty(list))
          saveStaffFamily(list); 
        returnVo.setSuccess(true);
        returnVo.setRetMessage("删除成功");
        returnVo.setRetCode("200");
        returnVo.setRetUrl("/medical/deleteStaffFamily");
      } else {
        returnVo.setSuccess(false);
        returnVo.setRetMessage("删除失败");
        returnVo.setRetCode("400");
        returnVo.setRetUrl("/medical/deleteStaffFamily");
      } 
    } catch (BusinessException e) {
      log.error("medical/deleteStaffFamily:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo selectNextUser(CandidateVo candidateVo) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    try {
      if (StringUtil.isEmpty(candidateVo.getUserId())) {
        returnVo.setRetMessage("参数错误");
        return returnVo;
      } 
      List<String> sInstanceIdLst = this.medicalExpenseMapper.selectNextUser(candidateVo.getUserId(), "QYZXQS_MEDICAL_AID", Integer.valueOf(1), candidateVo.getSUserGuid());
      if (!CollectionUtils.isEmpty(sInstanceIdLst))
        returnVo = this.flowClient.selectLastUser(sInstanceIdLst.get(0), candidateVo.getUserId(), "QYZXQS_MEDICAL_AID"); 
    } catch (BusinessException e) {
      log.error("medical/selectNextUser:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateWorkFlow(CnFlowHistory flowHistory) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(flowHistory.getsLastUserid()) || 
      StringUtil.isEmpty(flowHistory.getsPrevTaskId()) || 
      StringUtil.isEmpty(flowHistory.getsPrevTaskName()) || 
      StringUtil.isEmpty(flowHistory.getsPrevUserid()) || 
      StringUtil.isEmpty(flowHistory.getsPrevUsername())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      HashMap<String, String> map = new HashMap<>();
      map.put("path", "LocalWorkflow");
      List<String> sRoles = this.ssOrgMapper.selectRoleGuidByLoginGuid(flowHistory.getsPrevUserid());
      StringBuffer sbRoles = new StringBuffer();
      if (null != sRoles && sRoles.size() > 0)
        for (int i = 0; i < sRoles.size(); i++) {
          if (i == sRoles.size() - 1) {
            sbRoles = sbRoles.append(sRoles.get(i));
          } else {
            sbRoles = sbRoles.append(sRoles.get(i)).append(",");
          } 
        }  
      map.put("workflowTaskGroup", sbRoles.toString());
      List<SmFamilyDto> smFamilyDtoList = null;
      if (StringUtil.isEmpty(flowHistory.getsUserGuid())) {
        smFamilyDtoList = this.medicalExpenseMapper.querySubmitDetall(flowHistory.getsLastUserid(), "QYZXQS_MEDICAL_AID", null, null, null);
      } else {
        smFamilyDtoList = this.medicalExpenseMapper.querySubmitDetall(flowHistory.getsLastUserid(), "QYZXQS_MEDICAL_AID", flowHistory.getsUserGuid(), flowHistory.getsReferenceId(), flowHistory.getsInstanceId());
      } 
      List<CnFlowHistory> flowHistoryLst = new ArrayList<>();
      if (!CollectionUtils.isEmpty(smFamilyDtoList)) {
        CnFlowHistory cnFlowHistory1 = new CnFlowHistory();
        BeanUtils.copyProperties(flowHistory, cnFlowHistory1);
        cnFlowHistory1.setsServiceName(this.sServiceName);
        cnFlowHistory1.setsVariables(map);
        cnFlowHistory1.setsInstanceId(((SmFamilyDto)smFamilyDtoList.get(0)).getsInstanceId());
        cnFlowHistory1.setsDefintionId("QYZXQS_MEDICAL_AID");
        cnFlowHistory1.setsOperationType("SEND_WORKFLOW_NEXT");
        cnFlowHistory1.setdOperationDate(new Date());
        flowHistoryLst.add(cnFlowHistory1);
      } 
      CnFlowHistory cnFlowHistory = this.flowClient.sendWorkFlowLst(flowHistoryLst);
      if (null != cnFlowHistory.getsVariables() && null != cnFlowHistory.getsVariables().get("errorMes")) {
        returnVo.setSuccess(false);
        returnVo.setRetMessage("提交失败" + cnFlowHistory.getsVariables().get("errorMes").toString());
      } else {
        if (!CollectionUtils.isEmpty(smFamilyDtoList))
          smFamilyDtoList.forEach(it -> this.medicalExpenseMapper.updateFlagStandard(it.getsInstanceId(), "0")); 
        returnVo.setSuccess(true);
        returnVo.setRetMessage("提交成功");
      } 
    } catch (BusinessException e) {
      log.error("medical/updateWorkFlow:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateBatchWorkFlow(FlowHistoryQuery flowHistory) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(flowHistory.getSLastUserid()) || 
      StringUtil.isEmpty(flowHistory.getSPrevTaskId()) || 
      StringUtil.isEmpty(flowHistory.getSPrevTaskName()) || 
      StringUtil.isEmpty(flowHistory.getSPrevUserid()) || 
      StringUtil.isEmpty(flowHistory.getSPrevUsername())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      HashMap<String, String> map = new HashMap<>();
      map.put("path", "LocalWorkflow");
      List<String> sRoles = this.ssOrgMapper.selectRoleGuidByLoginGuid(flowHistory.getSPrevUserid());
      StringBuffer sbRoles = new StringBuffer();
      if (null != sRoles && sRoles.size() > 0)
        for (int i = 0; i < sRoles.size(); i++) {
          if (i == sRoles.size() - 1) {
            sbRoles = sbRoles.append(sRoles.get(i));
          } else {
            sbRoles = sbRoles.append(sRoles.get(i)).append(",");
          } 
        }  
      map.put("workflowTaskGroup", sbRoles.toString());
      for (Object flow : flowHistory.getSUserGuid()) {
        List<SmFamilyDto> smFamilyDtoList = this.medicalExpenseMapper.querySubmitDetallTwo(flowHistory.getSLastUserid(), "QYZXQS_MEDICAL_AID", flow.toString(), flowHistory.getSDeptHid(), flowHistory.getSInstanceId());
        Set<String> flowHistoryLst2 = new HashSet<>();
        if (!CollectionUtils.isEmpty(smFamilyDtoList)) {
          for (SmFamilyDto smFamilyDto : smFamilyDtoList)
            flowHistoryLst2.add(smFamilyDto.getsInstanceId()); 
          for (String flowhistory : flowHistoryLst2) {
            CnFlowHistory cnFlowHistory = new CnFlowHistory();
            BeanUtils.copyProperties(flowHistory, cnFlowHistory);
            cnFlowHistory.setsServiceName(this.sServiceName);
            cnFlowHistory.setsVariables(map);
            cnFlowHistory.setsInstanceId(flowhistory);
            cnFlowHistory.setsDefintionId("QYZXQS_MEDICAL_AID");
            cnFlowHistory.setsOperationType("SEND_WORKFLOW_NEXT");
            cnFlowHistory.setdOperationDate(new Date());
            CnFlowHistory history = this.flowClient.sendWorkFlow(cnFlowHistory);
            if (null == history || null == history.getnStep() || history.getnStep().intValue() != 99) {
              returnVo.setSuccess(false);
              returnVo.setRetMessage("提交失败");
              continue;
            } 
            this.medicalExpenseMapper.updateFlagStandard(cnFlowHistory.getsInstanceId(), "0");
          } 
        } 
        returnVo.setSuccess(true);
        returnVo.setRetMessage("提交成功");
      } 
    } catch (BusinessException e) {
      log.error("medical/updateWorkFlow:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo saveCompletion(CnFlowHistory flowHistory) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(flowHistory.getsLastUserid())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    List<SmFamilyDto> smFamilyDtoLs = this.smFamilyDetailSnapMapper.querySubmitDetallInstanceId(flowHistory.getsLastUserid(), "QYZXQS_MEDICAL_AID", "2", flowHistory.getsUnitCode());
    if (CollectionUtils.isEmpty(smFamilyDtoLs)) {
      returnVo.setRetMessage("未做汇总操作！");
      return returnVo;
    } 
    try {
      HashMap<String, String> map = new HashMap<>();
      map.put("path", "LocalWorkflow");
      List<String> sRoles = this.ssOrgMapper.selectRoleGuidByLoginGuid(flowHistory.getsLastUserid());
      StringBuffer sbRoles = new StringBuffer();
      if (null != sRoles && sRoles.size() > 0)
        for (int i = 0; i < sRoles.size(); i++) {
          if (i == sRoles.size() - 1) {
            sbRoles = sbRoles.append(sRoles.get(i));
          } else {
            sbRoles = sbRoles.append(sRoles.get(i)).append(",");
          } 
        }  
      map.put("workflowTaskGroup", sbRoles.toString());
      List<CnFlowHistory> flowHistoryLst = new ArrayList<>();
      for (SmFamilyDto smFamilyDto : smFamilyDtoLs) {
        CnFlowHistory cnFlowHistory = new CnFlowHistory();
        BeanUtils.copyProperties(flowHistory, cnFlowHistory);
        cnFlowHistory.setsServiceName(this.sServiceName);
        cnFlowHistory.setsVariables(map);
        cnFlowHistory.setsInstanceId(smFamilyDto.getsInstanceId());
        cnFlowHistory.setsDefintionId("QYZXQS_MEDICAL_AID");
        cnFlowHistory.setsOperationType("FINISH_WORKFLOW");
        cnFlowHistory.setdOperationDate(new Date());
        flowHistoryLst.add(cnFlowHistory);
      } 
      this.medicalExpenseMapper.updateBatchStatus(flowHistory.getsLastUserid(), "QYZXQS_MEDICAL_AID", "2", "4", flowHistory.getsUnitCode());
      boolean send = this.mqUtils.sendLst(flowHistoryLst);
      if (!send) {
        returnVo.setSuccess(false);
        returnVo.setRetMessage("提交失败");
      } else {
        log.info("medical/completion:发送mq成功");
        List<SmFamilyDetailSnap> smFamilyDetailSnapList = this.medicalExpenseMapper.selectBatchStatus("4");
        int intValue = (new Double(Math.ceil(smFamilyDetailSnapList.size() / 1000.0D))).intValue();
        List<SmFamilyDetailSnap> newLst = new ArrayList<>();
        for (int i = 0; i < intValue; i++) {
          if (i < intValue - 1) {
            newLst = smFamilyDetailSnapList.subList(i * 1000, (i + 1) * 1000);
          } else {
            newLst = smFamilyDetailSnapList.subList(i * 1000, smFamilyDetailSnapList.size());
          } 
          this.medicalExpenseMapper.insertBatch(newLst);
        } 
        Integer num = this.smApplyStaffMapper.insertBatchFamily(flowHistory.getsLastUserid(), flowHistory.getsLastUsername(), "QYZXQS_MEDICAL_AID", "4");
        this.smFamilyDetailSnapMapper.updateStatus("4", "3");
        this.medicalExpenseMapper.updateStatus("4", "3");
        returnVo.setSuccess(true);
        returnVo.setRetMessage("办结成功");
      } 
    } catch (BusinessException e) {
      log.error("medical/completion:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo unitCheck(UnitCheckQuery query) {
    log.info("[供养直系亲属医疗费用补助][单位审核][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      query.setSState("0");
      List<SmFamilyDto> unitCheckList = this.medicalExpenseMapper.unitCheckQueryList(query);
      unitCheckList.forEach(item -> {
            BigDecimal payStandard = item.getnPayStandard();
            Double payStandards = Double.valueOf(String.valueOf(payStandard));
            BigDecimal nScale = item.getnScale();
            Double nScaleOne = Double.valueOf(String.valueOf(nScale));
            BigDecimal nWithinMaxMoney = item.getnWithinMaxMoney();
            Double withinMaxMoney = Double.valueOf(String.valueOf(nWithinMaxMoney));
            if (item.getnSubmitmoney() != null) {
              double totalMoney = (Double.valueOf(String.valueOf(item.getnSubmitmoney())).doubleValue() - payStandards.doubleValue()) * nScaleOne.doubleValue();
              double submitmoney = Double.valueOf(String.valueOf(item.getnSubmitmoney())).doubleValue();
              if (withinMaxMoney.doubleValue() >= totalMoney) {
                if (totalMoney > 0.0D) {
                  item.setTotalMoney(Double.valueOf(totalMoney));
                } else {
                  item.setTotalMoney(Double.valueOf(0.0D));
                } 
              } else {
                item.setTotalMoney(withinMaxMoney);
              } 
              if (submitmoney >= withinMaxMoney.doubleValue()) {
                item.setnSubmitmoney(BigDecimal.valueOf(withinMaxMoney.doubleValue()));
              } else {
                item.setnSubmitmoney(BigDecimal.valueOf(submitmoney));
              } 
            } 
          });
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(unitCheckList);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
    } catch (BusinessException e) {
      log.error("medical/unitCheck:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo queryUnitUserInfo(UnitCheckQuery query) {
    log.info("[供养直系亲属医疗费用补助][单位审核][查询单位下边所有人员]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setSuccess(false);
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      List<String> sTaskGroupIdLst = this.ssOrgMapper.selectTaskGroupId(query.getSDefintionId(), query.getSTaskId());
      if (CollectionUtils.isEmpty(sTaskGroupIdLst)) {
        log.info("[用户单位权限查询接口]" + query.getSDefintionId() + "未分配单位权限");
        returnVo.setRetMessage("[用户单位权限查询接口]" + query.getSDefintionId() + "未分配单位权限");
        return returnVo;
      } 
      List<String> newTaskGroupIdLst = new ArrayList<>();
      for (String str : sTaskGroupIdLst) {
        String[] aa = str.split(",");
        for (int i = 0; i < aa.length; i++)
          newTaskGroupIdLst.add(aa[i]); 
      } 
      List<SsOrg> ssOrgLst = this.ssOrgMapper.selectUnitGuid(query.getUserId(), newTaskGroupIdLst);
      if (CollectionUtils.isEmpty(ssOrgLst)) {
        log.info("[用户单位权限查询接口]" + query.getSDefintionId() + "未分配单位");
        returnVo.setRetMessage("未分配单位");
        return returnVo;
      } 
      List<String> unitGuidList = new ArrayList<>();
      for (SsOrg ssOrg : ssOrgLst)
        unitGuidList.add(ssOrg.getHid()); 
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      List<SmSzyDto> unitUserInfo = this.medicalExpenseMapper.queryUnitUserInfo(query, unitGuidList);
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmSzyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(unitUserInfo);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
    } catch (BusinessException e) {
      log.error("medical/queryUnitUserInfo:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo hrCheck(HrCheckQuery query) {
    log.info("[供养直系亲属医疗费用补助][人资审核][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      query.setStatus("1");
      List<SmFamilyDto> hrCheckList = this.medicalExpenseMapper.hrCheckQueryList(query);
      hrCheckList.forEach(item -> {
            BigDecimal payStandard = item.getnPayStandard();
            Double payStandards = Double.valueOf(String.valueOf(payStandard));
            BigDecimal nScale = item.getnScale();
            Double nScaleOne = Double.valueOf(String.valueOf(nScale));
            BigDecimal nWithinMaxMoney = item.getnWithinMaxMoney();
            Double withinMaxMoney = Double.valueOf(String.valueOf(nWithinMaxMoney));
            if (item.getnSubmitmoney() != null) {
              double totalMoney = (Double.valueOf(String.valueOf(item.getnSubmitmoney())).doubleValue() - payStandards.doubleValue()) * nScaleOne.doubleValue();
              double submitmoney = Double.valueOf(String.valueOf(item.getnSubmitmoney())).doubleValue();
              if (withinMaxMoney.doubleValue() >= totalMoney) {
                if (totalMoney > 0.0D) {
                  item.setTotalMoney(Double.valueOf(totalMoney));
                } else {
                  item.setTotalMoney(Double.valueOf(0.0D));
                } 
              } else {
                item.setTotalMoney(withinMaxMoney);
              } 
              if (submitmoney >= withinMaxMoney.doubleValue()) {
                item.setnSubmitmoney(BigDecimal.valueOf(withinMaxMoney.doubleValue()));
              } else {
                item.setnSubmitmoney(BigDecimal.valueOf(submitmoney));
              } 
            } 
          });
      if (CollectionUtil.isNotEmpty(hrCheckList))
        hrCheckList.forEach(s -> {
              List<SmsRecordVo> smsRecordVos = this.smsRecordMapper.selectByEmpGuidAndModel(s.getsUserGuid(), "SMS_463765529");
              if (CollectionUtil.isNotEmpty(smsRecordVos)) {
                s.setsSendSms(Boolean.TRUE.booleanValue());
              } else {
                s.setsSendSms(Boolean.FALSE.booleanValue());
              } 
            }); 
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(hrCheckList);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
    } catch (BusinessException e) {
      log.error("medical/hrCheck:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo querySummary(HrCheckQuery query) {
    log.info("[供养直系亲属医疗费用补助z][汇总][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getSImportDate())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      query.setStatus("2");
      List<SmFamilyDto> summary = this.medicalExpenseMapper.querySummary(query);
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(summary);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
    } catch (BusinessException e) {
      log.error("medical/querySummary:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  public ReturnVo queryCheckOut(HrCheckQuery query) {
    log.info("[供养直系亲属医疗费用补助][办结][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(query.getUserId()) || StringUtil.isEmpty(query.getSDefintionId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      Page page = PageHelper.startPage(query.getPageIndex(), query.getPageSize());
      List<SmFamilyDto> checkOut = this.medicalExpenseMapper.queryCheckOut(query);
      List<SmFamilyDto> submitMoneyList = this.medicalExpenseMapper.queryTotalMoney(query.getUserId());
      Map<Object, Object> map = new HashMap<>();
      if (!ObjectUtils.isEmpty(checkOut)) {
        BigDecimal totalMoney01 = this.medicalExpenseMapper.queryStaffFamilyList(((SmFamilyDto)checkOut.get(0)).getsFamilyGuid(), null);
        BigDecimal totalMoney03 = this.medicalExpenseMapper.queryStaffFamilyList(null, ((SmFamilyDto)checkOut.get(0)).getsCreateUser());
        if (totalMoney01 != null) {
          Double totalMoney02 = Double.valueOf(String.valueOf(totalMoney01));
          Double totalMoney04 = Double.valueOf(String.valueOf(totalMoney03));
          if (totalMoney02.doubleValue() <= totalMoney04.doubleValue() && totalMoney04.doubleValue() <= 50000.0D) {
            if (totalMoney02.doubleValue() > 0.0D) {
              map.put("totalMoney", totalMoney02);
            } else {
              map.put("totalMoney", Integer.valueOf(0));
            } 
          } else {
            map.put("totalMoney", Integer.valueOf(50000));
          } 
        } else {
          map.put("totalMoney", Integer.valueOf(0));
        } 
      } 
      map.put("submitMoneyList", submitMoneyList);
      Long countNums = Long.valueOf(page.getTotal());
      PageBean<SmFamilyDto> pageBean = new PageBean(Integer.valueOf(query.getPageIndex()), Integer.valueOf(query.getPageSize()), Integer.valueOf(countNums.intValue()));
      pageBean.setItems(checkOut);
      returnVo.setSuccess(true);
      returnVo.setRetMessage("查询成功");
      returnVo.setObj(pageBean);
      returnVo.setMap(map);
    } catch (BusinessException e) {
      log.error("medical/queryCheckOut:" + e.getMessage());
      returnVo.setSuccess(false);
      returnVo.setRetMessage(ENUM_EXCEPTION_CODE.ORACLE_SERVICE_ERROR.getMessage());
    } 
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateBackLastWorkFlow(CnFlowHistory flowHistory) {
    log.info("[供养直系亲属医疗费用补助][][驳回][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(flowHistory.getsInstanceId())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    try {
      List<String> instanceIdList = this.medicalExpenseMapper.getsInstanceIdList(flowHistory.getsInstanceId(), flowHistory.getsUserGuid(), flowHistory.getsReferenceId());
      Set<String> instanceIdSet = new HashSet<>();
      if (instanceIdList.size() > 0 && instanceIdList != null) {
        for (String instance : instanceIdList)
          instanceIdSet.add(instance); 
        for (String item : instanceIdSet) {
          flowHistory.setsOperationType("BACK_WORKFLOW_LAST");
          flowHistory.setsInstanceId(item);
          CnFlowHistory cnFlowHistory = this.flowClient.backLastWorkFlow(flowHistory);
          if (null != cnFlowHistory.getsVariables() && null != cnFlowHistory.getsVariables().get("errorMes")) {
            returnVo.setSuccess(false);
            returnVo.setRetMessage(cnFlowHistory.getsVariables().get("errorMes").toString());
            continue;
          } 
          String userId = this.medicalExpenseMapper.selectUserId(item);
          String userIdTwo = this.medicalExpenseMapper.selectUserIdTwo(item);
          if (StringUtil.isNotEmpty(userId) && StringUtil.isNotEmpty(userIdTwo) && userId.equals(userIdTwo))
            this.medicalExpenseMapper.updateFlagStandard(item, "1"); 
          returnVo.setSuccess(true);
          returnVo.setRetMessage("驳回成功");
        } 
      } 
    } catch (BusinessException e) {
      returnVo.setSuccess(false);
      returnVo.setRetMessage("/medical/backLastWorkFlow:" + e.getMessage());
    } 
    return returnVo;
  }
  
  private ReturnVo getDroolsDto(String sTypename) {
    ReturnVo returnVo = new ReturnVo();
    DroolsDto droolsDto = new DroolsDto();
    SmRuleClass smRuleClass = new SmRuleClass();
    smRuleClass.setsTepename(sTypename);
    SmRuleClass sr = DroolsUtil.getSmRuleClass(smRuleClass);
    SmRuleClass srsjk = this.smStandardService.selectStandard(smRuleClass);
    if (!sr.getsVersionNo().equals(srsjk.getsVersionNo())) {
      sr.setsVersionNos(srsjk.getsVersionNos());
      returnVo = this.smStandardService.insterStandard(sr);
      return returnVo;
    } 
    droolsDto.setnScale((new BigDecimal(sr.getnFamilyProportion())).divide(new BigDecimal(100)));
    droolsDto.setnAvailableMoney(new BigDecimal(sr.getnSfamilyQuota()));
    returnVo.setSuccess(true);
    returnVo.setObj(droolsDto);
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updatePushSummaryList(HrCheckQuery summaryEntryVo) throws IOException {
    log.info("[供养直系亲属医疗费用汇总推送][][开始]");
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(summaryEntryVo.getUserId()) || StringUtil.isEmpty(summaryEntryVo.getSImportDate())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    List<SapDto> sapDtoList = new ArrayList<>();
    summaryEntryVo.setStatus("2");
    SapDto smFamilyDtos = this.medicalExpenseMapper.pushSummaryList(summaryEntryVo);
    smFamilyDtos.setAccountPeriod(DateUtil.getDateStr(new Date(), "yyyy-MM"));
    smFamilyDtos.setPersonnelNature("2");
    sapDtoList.add(smFamilyDtos);
    log.info("[供养直系亲属医疗费用汇总推送][推送SAP数据:{}]", JSON.toJSONString(sapDtoList));
    if (CollectionUtils.isEmpty(sapDtoList)) {
      returnVo.setSuccess(false);
      returnVo.setRetMessage("提交失败没有待推送数据");
      return returnVo;
    } 
    String send = HttpRequestUtil.sendExcelToReportForRunqianCommon(this.syncMedical, sapDtoList);
    if (!StringUtil.isEmpty(send)) {
      SapVo sapVo = (SapVo)JSON.parseObject(send, SapVo.class);
      if (null != sapVo && sapVo.getCode().intValue() == 0) {
        for (SapDto sapDtoo : sapDtoList) {
          SmSap smSap = new SmSap();
          smSap.setsGuid(UUIDUtil.get32UUID());
          smSap.setPersonnelNature(Short.valueOf(sapDtoo.getPersonnelNature()));
          smSap.setExpenseAmount(sapDtoo.getExpenseAmount());
          smSap.setInvoiceCount(Integer.valueOf(sapDtoo.getInvoiceCount().intValue()));
          smSap.setAccountPeriod(DateUtil.getDate(sapDtoo.getAccountPeriod(), "yyyy-MM"));
          smSap.setEmpTotal(Integer.valueOf(sapDtoo.getEmpTotal().intValue()));
          smSap.setEmpName(sapDtoo.getEmpName());
          smSap.setsCreateUser(summaryEntryVo.getUserId());
          smSap.setdCreateDate(new Date());
          smSap.setsDeleteFlag("0");
          this.smSapMapper.insertSelective(smSap);
        } 
        returnVo.setSuccess(true);
        returnVo.setRetMessage("推送成功");
        returnVo.setObj(send);
        log.info("[供养直系亲属医疗费用汇总推送][][结束]");
        return returnVo;
      } 
      returnVo.setSuccess(false);
      returnVo.setRetMessage("推送汇总数据,调用自助服务平台失败!");
      return returnVo;
    } 
    returnVo.setSuccess(false);
    returnVo.setRetMessage("推送汇总数据,调用自助服务平台失败!");
    return returnVo;
  }
  
  @Transactional
  public ReturnVo updateSummaryMonth(CnFlowHistory flowHistory) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(flowHistory.getsLastUserid())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    List<SmFamilyDto> smFamilyDtoLs = this.smFamilyDetailSnapMapper.querySubmitDetall(flowHistory.getsLastUserid(), "QYZXQS_MEDICAL_AID", flowHistory.getsUnitCode(), flowHistory.getsInstanceId(), "1");
    if (CollectionUtils.isEmpty(smFamilyDtoLs)) {
      returnVo.setRetMessage("没有待汇总数据");
      return returnVo;
    } 
    HrCheckQuery query = new HrCheckQuery();
    query.setUserId(flowHistory.getsLastUserid());
    query.setSDefintionId("QYZXQS_MEDICAL_AID");
    query.setAbnormal("1");
    query.setSDeptHid(flowHistory.getsUnitCode());
    query.setSInstanceId(flowHistory.getsInstanceId());
    List<SmFamilyDto> hrCheckList = this.medicalExpenseMapper.hrCheckQueryList(query);
    if (!CollectionUtils.isEmpty(hrCheckList)) {
      StringBuffer stringBuffer = new StringBuffer("以下人员银行卡信息异常：");
      for (SmFamilyDto smFamilyDto : hrCheckList)
        stringBuffer.append(smFamilyDto.getsPersonName() + ":" + smFamilyDto.getsPersonIdcardNo() + ","); 
      returnVo.setRetMessage(stringBuffer.toString());
      return returnVo;
    } 
    String sImportDate = DateUtil.getDateStr(new Date(), "yyyy-MM");
    this.smFamilyDetailSnapMapper.updateBatchSummaryMonth(flowHistory.getsLastUserid(), flowHistory.getsLastUsername(), "QYZXQS_MEDICAL_AID", "1", "2", sImportDate, flowHistory.getsInstanceId(), flowHistory.getsUnitCode());
    returnVo.setSuccess(true);
    returnVo.setRetMessage("汇总成功");
    return returnVo;
  }
  
  public ReturnVo queryFinanceConfirm(FinanceConfirmQuery financeConfirm) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(financeConfirm.getSImportDate())) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    Page page = PageHelper.startPage(financeConfirm.getPageIndex(), financeConfirm.getPageSize());
    financeConfirm.setStatus("2");
    List<SmFamilyDto> smApplyDetailDtoLst = this.smFamilyDetailSnapMapper.queryFinanceConfirm(financeConfirm);
    Long countNums = Long.valueOf(page.getTotal());
    PageBean pageBean = new PageBean(Integer.valueOf(financeConfirm.getPageIndex()), Integer.valueOf(financeConfirm.getPageSize()), Integer.valueOf(countNums.intValue()));
    pageBean.setItems(smApplyDetailDtoLst);
    returnVo.setSuccess(true);
    returnVo.setRetMessage("查询成功");
    returnVo.setObj(pageBean);
    return returnVo;
  }
  
  public ReturnVo queryFinanceDetall(int pageIndex, int pageSize, String sCompanyHid, String sImportDate, String sBankName) {
    ReturnVo returnVo = new ReturnVo();
    returnVo.setSuccess(false);
    if (StringUtil.isEmpty(sImportDate) || StringUtil.isEmpty(sBankName)) {
      returnVo.setRetMessage("参数错误");
      return returnVo;
    } 
    Page page = PageHelper.startPage(pageIndex, pageSize);
    List<SmApplyDetailDto> smApplyDetailDtoLst = this.smFamilyDetailSnapMapper.queryFinanceDetall(sCompanyHid, sImportDate, sBankName);
    Long countNums = Long.valueOf(page.getTotal());
    PageBean pageBean = new PageBean(Integer.valueOf(pageIndex), Integer.valueOf(pageSize), Integer.valueOf(countNums.intValue()));
    pageBean.setItems(smApplyDetailDtoLst);
    returnVo.setSuccess(true);
    returnVo.setRetMessage("查询成功");
    returnVo.setObj(pageBean);
    return returnVo;
  }
}
